!- TRIANGULAR μOS 1.17 for Commodore VIC-20 8KB
!- UOS


!- Set BASIC variables & launch hardware tests & set memory variables // set poke808,127 in the final version
1print"{clear}{cyan}{ct h}{142}":clr:poke808,127:poke36879,8:q$=chr$(34):v$="1.17":pa=65532:gosub9:iffre(x)<7600thenprint"{clear}{red}not enough ram!":goto23
2gosub21:gosub25:fm=int(fre(x)/1024)+6:gosub9:gosub10:dd=1:poke998,fm:poke909,dd:poke993,10:poke992,10:poke911,.:poke990,158:poke994,31:poke996,.:poke997,230:poke992,10:poke993,10:poke991,1:n$="gui":bs=peek(900):ifbs<8andbs>11thenbs=8

!- Launch screen
3bi=.:print"{clear}";:gosub9:print"{purple}{cm @*22}";:gosub56:print"    {cm asterisk}{reverse on}            {reverse off}{sh pound}":gosub57:print"      {cm asterisk}{reverse on}        {reverse off}{sh pound}":gosub57:print"        {cm asterisk}{reverse on}    {reverse off}{sh pound}":gosub57:print"          {cm asterisk}{sh pound}":gosub57
4print"{blue}{down*2} {cm c}{reverse on}{cm d}{cm k}{reverse off}{cm b}{reverse on}{cm k}{reverse off}{cm d}{cm b}{reverse on}{cm k}{reverse off}{cm f}{cm k}{reverse on}{cm b}{reverse off}{cm v}{cm k*3} {reverse on}{cm b}{reverse off}{cm f}{reverse on}{cm d}{reverse off}{cm f}{return}  {cm k}{reverse on}{cm k}{reverse off}{cm b}{reverse on}{cm k*2}{cm f}{cm k}{reverse off}{cm c}{cm k*6} {reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm f}{return}  {cm v}{cm c*6} {cm v}{cm c}{cm v}{reverse on}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v*5}{return}{cyan}{down}(c)2023      {cm m}{cm x}os "v$
5gosub9:ifrn=.then76
6printtab(9)"{down*2}{reverse on}{yellow}f1{reverse off} {green}bios setup";:poke198,.:gosub12
7getk$:ifk$="{f1}"then27

!- Load GUI
8print"{clear}{down*12}"tab(8)"{purple}{cm asterisk}{reverse on}    {reverse off}{sh pound}{down}{left*5}{cm asterisk}{reverse on}  {reverse off}{sh pound}{down}{left*3}{cm asterisk}{sh pound}{return}{down*2}{white}     {cm @*12}{return}{white}    {cm m}{reverse on}{blue}{cm m*7}{reverse off}     {white}{cm g}{return}{white}     {cm t*12}{return}{white}{down}      loading...{home}{black}load "q$n$q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new

!- Delay 500 for's
9forj=.to500:nextj:return

!- Beep sound
10poke36878,15:poke36876,218:forj=1to120:nextj:poke36876,.:forj=1to100:nextj:return

!- Beep sound x3
11gosub10:gosub10:gosub10:return

!- Delay 2000 for's
12fori=.to2000:nexti:return

!- Disk dirve tests (drive # evaluatian: 8+di)
13open1,8+di,2:close1:ifst<>.then17
14gosub20:ifer$=""then17
15open1,8+di,15:print#1,"m-r";chr$(51);chr$(255):get#1,d$:t1=asc(d$+chr$(.)):close1:vt$="":open5,8+di,5,"uos.cfg,s,r":input#5,vt$:close5:gosub20:poke901+di,1:poke905+di,t1:bi=1:ifv$=vt$then18
16return
17poke901+di,.:poke905+di,.:return

18bd=8+di:ifbs=bdthent=1
19return

!- Read disk error channel
20open1,8+di,15:input#1,en,er$,tr,sc:close1:return

!- Commodore VIC-20 type confirmation
21poke198,.:poke631,167:poke632,189:poke198,2:geta$:getb$:a$=a$+b$:ifa$="{cm m}{cm x}"andpeek(pa)=34andpeek(pa+1)=253then24
22print"{clear}{red}this computer can't{return}run this{cm m}{cm x}os version!"

!- Go back to BASIC
23gosub11:gosub9:poke36879,27:print"{blue}{down*2}**** cbm basic v2 ****{down}{left}"((int(fre(x)/1024)+4.5)*1024)-1"bytes free{ct i}":poke808,112:new
24poke986,198:poke1000,3:restore:fori=.to5:readd:poke980+i,d:nexti:return:data19,13,82,85,78,13

!- Cursor test & screen mode detection
25print"{clear}{down}{cm p}";:gosub9:ifpeek(((peek(648))*256)+22)=111thenpoke999,22:return
26print"{clear}":gosub9:print"{clear}{red}this graphic mode{return}is not supported!":goto23

!- BIOS Setup menu
27print"{clear}{purple}{cm asterisk}{reverse on}  {reverse off}{sh pound}{cyan} triangular bios{return} {purple}{cm asterisk}{sh pound}{cyan}  (c)2023{down*2}{return} {blue}c{red}= {cyan}vic-20"fm"{left}kb ram{down}{return} #: device: boot/work":cs$="none":ifcs=1thencs$="cbm datasette":
28db=dd:wb=wd:bb=bd:print" {reverse on}{red}1{cyan}{reverse off}: ":gosub85:fori=.to3
29gosub64:print8+i;"{left}:",:ifdi(i)=.thenprint"{left*7}none"
30ifdi(i)=1thenprint"{left*7}cbm "dt$(i)"{return}","{up}{right*2}{reverse on}{yellow}"(i*2)+1"{left*3}f{right*3}{green}"(i*2)+2"{left*3}f{reverse off}{cyan}"
31nexti:print"{down} boot:     work:{return}{down*2} {reverse on}{red}t{cyan}{reverse off}ime:{return}{down} {reverse on}{red}r{cyan}{reverse off}eset clock{return}{down*2} {reverse on}{red}e{cyan}{reverse off}xit {reverse on}{red}s{cyan}{reverse off}ave {reverse on}{red}b{cyan}{reverse off}asic":poke198,.
32gosub58:gosub63:getk$:ifk$=""then32
33ifk$="e"thenprint"{clear}":dd=db:wd=wb:bd=bb:goto3
34ifk$="r"thenti$="000000"
35ifk$="1"thengosub88:gosub85
36ifk$="{f1}"theni=.:gosub59
37ifk$="{f2}"theni=.:gosub61
38ifk$="{f3}"theni=1:gosub59
39ifk$="{f4}"theni=1:gosub61
40ifk$="{f5}"theni=2:gosub59
41ifk$="{f6}"theni=2:gosub61
42ifk$="{f7}"theni=3:gosub59
43ifk$="{f8}"theni=3:gosub61
44ifk$="t"thengosub50
45ifk$="s"then48
46ifk$="b"thensys64802
47goto32

48open1,bd,15,"r0:uos=uos":close1:gosub84:ifer=62orer=21orer=74thengosub10:gosub10:goto32
49gosub83:n$="uos":goto8

!- Time change
50ks$="":kv$="":poke198,.:fori=.to5
51gosub58:gosub63:print"{down}{right*7}{blue}"kv$"{cyan}":getk$:ifk$=""then51
52as=asc(k$):ifas>47andas<58thenks$=ks$+k$:goto54
53goto51

!- Load GUI
54kv$=kv$+k$:ifi=1ori=3thenkv$=kv$+":"
55nexti:gosub63:print"{down}{right*7}       ":ti$=ks$:poke198,.:return

!- Draw horizontal line 1
56print"{sh asterisk*22}";:return

!- Draw horizontal line 2
57print"{cm t*22}";:return

!- Time update > setup
58t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):print"{home}{down*16}{right*7}"t1$":"t2$":"t3$:return

!- Set Boot drive
59ifpeek(901+i)=1thenbd=8+i:return
60return

!- Set Work drive
61ifpeek(901+i)=1thenwd=8+i:return
62return

!- Boot & Work disk drive update > setup
63print"{home}{down*13}{right*6}{yellow}"bd"{left} ","{right*5}{green}"wd"{left} {cyan}":return

!- Disk drive database
64di(i)=peek(901+i):dn(i)=peek(905+i):dt$(i)="{left*4}unknown":ifdi(i)=.thenreturn
65ifdn(i)=16thendt$(i)="2040"
66ifdn(i)=76thendt$(i)="1541"
67ifdn(i)=170thendt$(i)="1540"
68ifdn(i)=173thendt$(i)="1571"
69ifdn(i)=108thendt$(i)="1581"
70ifdn(i)=7thendt$(i)="2031"
71ifdn(i)=32thendt$(i)="3040"
72ifdn(i)=169thendt$(i)="4040"
73ifdn(i)=255thendt$(i)="1551"
74ifdn(i)=48thendt$(i)="{left*4}sd2iec"
75return

!- Check disk drives
76t=.:fordi=3to.step-1:gosub13:nextdi:ift=1thenbd=bs
77 wd=bd:dd=peek(909):fm=peek(998):poke900,bd:poke910,wd
78ifbi=.thenee$="   {reverse on}no disk drive!{reverse off}":goto91
79ifbd=.thenee$="   {reverse on}no system disk!{reverse off}":goto91

!- Load uos.cfg
80rn=1:open8,bd,8,"uos.cfg,s,r":close8:gosub84:poke991,1:ifer<>.then91
81open8,bd,8,"uos.cfg,s,r":input#8,v1$,wd$,dd$,gc$,gr$,cg$,tc$,pp$:close8:gosub84:poke997,val(gr$):poke996,val(gc$):poke994,val(cg$):wd=val(wd$):dd=val(dd$):poke909,dd:ifpeek(893+wd)=.thenwd=bd
82poke910,wd:poke990,val(tc$):poke911,val(pp$):goto6

!- Save uos.cfg
83open1,bd,15,"s0:uos.cfg":close1:open8,bd,8,"uos.cfg,w,s":print#8,v$:print#8,wd:print#8,dd:print#8,peek(996):print#8,peek(997):print#8,peek(994)::print#8,peek(990):print#8,peek(911):close8:poke909,dd:poke900,bd:poke910,wd:gosub84:return

!- Read disk error chanell
84open1,bd,15:input#1,er,er$,tr,sc:close1:return

!- Update Datasette status graphic > setup
85ifdd=.thenprint"{home}{down*7}{right*4}none         ":return
86ifdd=1thenprint"{home}{down*7}{right*4}cbm datasette":return
87return

!- Datasette enable On/Off
88ifdd=.thendd=1:return
89ifdd=1thendd=.:return
90return

!- Disk drive error
91print"{red}"ee$"{return}{down}{yellow}{reverse on}f1{green}{reverse off} retry"tab(14)"{red}{reverse on}f8{green}{reverse off} basic";:poke198,.:gosub11
92getk$:ifk$="{f1}"thenr=.:goto3
93ifk$="{f8}"thensys64802
94goto92
