!- TRIANGULAR μOS 1.17 for Commodore VIC-20 8KB
!- MONITOR


!- Set variables
1 print"{clear}{142}":poke36879,104:q$=chr$(34):dimrn(3):dimhe(3):dimhe$(3):dimdc(3):as$="start address":bd=peek(900)

!- Command loop
2 gosub13
3 in$="":ip$="*":gosub42:c7=len(in$):fori=1to2:l$(i)=left$(in$,i):nexti:ifin$="exit"then17
4 ifin$="clr"then2
5 ifl$(2)="e>"then18
6 ifl$(2)="t>"then33
7 ifl$(2)="f>"then55
8 ifl$(2)="m>"then63
9 ifin$="help"thengosub81
10 ifl$(2)="g>"then14
11 ifl$(2)="s>"then84
12 print"{down} {yellow}invalid command!{white}":goto3

!- Draw main title
13 print"{clear}{purple}{cm asterisk}{reverse on}  {reverse off}{sh pound}{cyan}triangular monitor{purple} {cm asterisk}{sh pound}{cyan} (c)2023{white}":return

!- Go
14 ifc7<>6thengosub76:goto3
15 in$=right$(in$,4):hl=4:gosub27:ifr=1then14
16 sysdc:goto3

!- Load apps (exit)
17 print"{clear}":poke36879,8:print"{down*12}"tab(8)"{purple}{cm asterisk}{reverse on}    {reverse off}{sh pound}{down}{left*5}{cm asterisk}{reverse on}  {reverse off}{sh pound}{down}{left*3}{cm asterisk}{sh pound}{return}{down*2}{white}     {cm @*12}{return}{white}    {cm m}{reverse on}{blue}{cm m*7}{reverse off}     {white}{cm g}{return}{white}     {cm t*12}{return}{white}{down}      loading...{home}{black}load "q$"gui"q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new

!- Entry
18 ifc7<>6thengosub76:goto3
19 in$=right$(in$,4):hl=4:gosub27:ifr=1then18
20 ad=dc:hl=2
21 ot=ad:gosub49
22 ip$="address "+hw$:gosub43:ifin$="r"then25
23 ifr=2then3
24 gosub27:ifr=1then22
25 pokead,dc
26 ad=ad+1:goto21

!- Max digit test
27 r=.:dc=.:nl=len(in$):ifnl>hlthenprint"{down}{yellow} max"hl"digits!{white}":r=1:return
28 r=.:fori=1tonl:td$=mid$(in$,i,1):tn=asc(td$):iftn>47andtn<58thentd=tn-48:goto31
29 iftn>64andtn<71thentd=tn-55:goto31
30 r=1
31 dc=dc+(td*(16^(nl-i))):nexti:ifr=1thenreturn
32 return

!- Copy
33 ifc7<>16thengosub76:goto3
34 l$=in$:in$=mid$(l$,3,4):hl=4:gosub27:ifr=1thengosub76:goto3
35 a1=dc:ifmid$(l$,7,1)<>"-"thengosub76:goto3
36 in$=mid$(l$,8,4):hl=4:gosub27:ifr=1thengosub76:goto3
37 ifdc<a1thenprint"{down} 2nd address lower than 1st!":goto3
38 a2=dc:ifmid$(l$,12,1)<>"="thengosub76:goto3
39 in$=right$(l$,4):hl=4:gosub27:ifr=1thengosub76:goto3
40 ad=dc:j=.:fori=a1toa2:mv=peek(i):if(ad+j)>65535thenj=j-1
41 pokead+j,mv:j=j+1:nexti:goto3

!- Command entry
42 print"{down}"ip$":";:open1,.:input#1,in$:close1:print"{white}{reverse off}":return

!- Entry adress
43 r=.:gosub42:gosub47:ifr=1orr=2thenreturn
44 return

!- Stop on X
45 r=.:gosub47:ifr=1orr=2thenreturn
46 return

!- Check for X-stop
47 ifin$="x"thenr=2:return
48 return

!- Convert hex to dec
49 he(.)=int(ot/4096):he(1)=int((ot-(he(.)*4096))/256)
50 he(2)=int((ot-(he(.)*4096)-(he(1)*256))/16)
51 he(3)=ot-(he(.)*4096)-(he(1)*256)-(he(2)*16)
52 forg=.to3:ifhe(g)<10thenhe$(g)=chr$(48+he(g))
53 ifhe(g)>9thenhe$(g)=chr$(55+he(g))
54 nextg:hw$=he$(.)+he$(1)+he$(2)+he$(3):return

!- Fill
55 ifc7<>14thengosub76:goto3
56 l$=in$:in$=mid$(l$,3,4):hl=4:gosub27:ifr=1thengosub76:goto3
57 a1=dc:ifmid$(l$,7,1)<>"-"thengosub76:goto3
58 in$=mid$(l$,8,4):hl=4:gosub27:ifr=1thengosub76:goto3
59 ifdc<a1thenprint"{down} 2nd address lower than 1st!":goto3
60 a2=dc:ifmid$(l$,12,1)<>"="thengosub76:goto3
61 in$=right$(l$,2):hl=2:gosub27:ifr=1thengosub76:goto3
62 mv=dc:fori=a1toa2:pokei,mv:nexti:goto3

!- Show
63 ifc7<>6thengosub76:goto3
64 in$=right$(in$,4):hl=4:gosub27:ifr=1then18
65 ad=dc
66 ifad<.thenad=.
67 ifad>65520thenad=65520
68 gosub13:fori=.to15step2:ot=ad+i:gosub49:print"{down} "hw$":";:ot=peek(ad+i)
69 gosub49:printright$(hw$,2);,;:ot=ad+i+1:gosub49:print" "hw$":";
70 ot=peek(ad+i+1):gosub49:printright$(hw$,2):nexti
71 print"{down*2} {green}{reverse on}f1{cyan}{reverse off} <  {green}{reverse on}f2{cyan}{reverse off} >  {yellow}{reverse on}f8{cyan}{reverse off} stop{white}"
72 geta$:ifa$="{f2}"thenad=ad+16:goto66
73 ifa$="{f1}"thenad=ad-16:goto66
74 ifa$="{f8}"then3
75 goto72

!- Bad parameter!
76 print"{down}{yellow} bad parameter!{white}":return

!- F1 to continue & F8 to stop
77 print"{down} {green}{reverse on}f1{reverse off}{cyan} to continue{down}{return} {yellow}{reverse on}f8{reverse off}{cyan} to stop";
78 getk$:ifk$="{f1}"thenreturn
79 ifk$="{f8}"thent=1:return
80 goto78

!- Help
81 gosub13:print"{down*2} monitor help:{return}{down*2} help - show help{return}{down} exit - quit to{return}"tab(8)"desktop{return}{down} e> - entry values{return}","{left*2}to memory{return}{down} m> - show memory{return}","{left*3}content":t=.:gosub77:ift=1then2
82 gosub13:print"{down*2} monitor help:{return}{down*2} f> - fill memory{return}","{left*3}block{return}{down} t> - copy memory{return}","{left*3}block{return}{down} s> - swipe memory{return}","{left*3}block{return}{down} g> - run assembler{return}"tab(6)"program":t=.:gosub77:ift=1then2
83 gosub13:print"{down*2} monitor help:{return}{down} clr - clears screen{return}{down*2} x - cancel entering{return}{right*5}numbers{return}{down} r - in entry mode{return}     repeat previous{return}     value":gosub77:goto2

!- Swipe
84 ifc7<>16thengosub76:goto3
85 l$=in$:in$=mid$(l$,3,4):hl=4:gosub27:ifr=1thengosub76:goto3
86 a1=dc:ifmid$(l$,7,1)<>"-"thengosub76:goto3
87 in$=mid$(l$,8,4):hl=4:gosub27:ifr=1thengosub76:goto3
88 ifdc<a1thenprint"{down} 2nd address lower than 1st!":goto3
89 a2=dc:ifmid$(l$,12,1)<>"="thengosub76:goto3
90 in$=right$(l$,4):hl=4:gosub27:ifr=1thengosub76:goto3
91 ad=dc:j=.
92 fori=a1toa2:mv=peek(i):if(ad+j)>65535thenj=j-1
93 k=peek(ad+j):pokei,k:pokead+j,mv:j=j+1:nexti:goto3
